# Source for file Oracle.php

Documentation is available at Oracle.php

1. <?php
2. /*
3. * $Id: Oracle.php 1619 2007-06-10 19:28:47Z zYne $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
21. Doctrine::autoload('Doctrine_Sequence');
22. /**
23. * Doctrine_Sequence_Oracle
24. *
25. * @package Doctrine
26. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
27. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28. * @category Object Relational Mapping
29. * @link www.phpdoctrine.com
30. * @since 1.0
31. * @version $Revision: 1619 $
32. */
33. class Doctrine_Sequence_Oracle extends Doctrine_Sequence
34. {
35. /**
36. * Returns the next free id of a sequence
37. *
38. * @param string $seqName name of the sequence
39. * @param bool onDemand when true missing sequences are automatic created
40. *
41. * @return integer next id in the given sequence
42. */
43. public function nextID($seqName, $onDemand = true)
44. {
45. $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
46. $query = 'SELECT ' . $sequenceName . '.nextval FROM DUAL';
48. try {
49. $result = $this->conn->fetchOne($query);
50. } catch(Doctrine_Connection_Exception $e) {
51. if ($onDemand && $e->getPortableCode() == Doctrine::ERR_NOSUCHTABLE) {
53. try {
54. $result = $this->conn->export->createSequence($seqName);
55. } catch(Doctrine_Exception $e) {
56. throw new Doctrine_Sequence_Exception('on demand sequence ' . $seqName . ' could not be created');
57. }
58. return $this->nextId($seqName, false);
59. }
60. throw $e;
61. }
62. return $result;
63. }
64. /**
65. * Returns the autoincrement ID if supported or $id or fetches the current
66. * ID in a sequence called: $table.(empty($field) ? '' : '_'.$field)
67. *
68. * @param string name of the table into which a new row was inserted
69. * @param string name of the field into which a new row was inserted
70. */
71. public function lastInsertID($table = null, $field = null)
72. {
73. $seqName = $table . (empty($field) ? '' : '_'.$field);
74. $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
76. return $this->conn->fetchOne('SELECT ' . $sequenceName . '.currval');
77. }
78. /**
79. * Returns the current id of a sequence
80. *
81. * @param string $seqName name of the sequence
82. *
83. * @return integer current id in the given sequence
84. */
85. public function currID($seqName)
86. {
87. $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
88. $query = 'SELECT (last_number-1) FROM user_sequences';
89. $query .= ' WHERE sequence_name=' . $this->conn->quote($sequenceName, 'text');
90. $query .= ' OR sequence_name=' . $this->conn->quote(strtoupper($sequenceName), 'text');
92. return $this->conn->fetchOne($query);
93. }
94. }